;*************************************************************************

; lib2obj.asm

; created with LLBasic

; LLBasic Copyright 2002,2003,by Greg Heller

;*************************************************************************



#include windows.inc

#include kernel32.inc

#include user32.inc



;*************************************************************************

; Compile-time Constants and #INCLUDES

;*************************************************************************





;*************************************************************************

; Data

;*************************************************************************



	data section "data$d"

	align 4

	;line 0,  LLBasic runtime variable

	my_Dword dd ?



	data section "data$f"

	align 1

	CommandLine$ db (256)+1 dup ?

	OutDirectory$ db (256)+1 dup ?

	InFile$ db (256)+1 dup ?

	OutFile$ db (256)+1 dup ?

	InText$ db (256)+1 dup ?



	data section "data$d"

	align 4

	hOutFile dd ?

	object_count dd 0

	lpOut dd 0

	byte_count dd 0



	data section "data$g"

	align 1

	whitespace db 9,32,0

	COMMAND$ db (256)+1 dup ?

	data section "data$z"

	dummy_label dd 0



;*************************************************************************

; Code

;*************************************************************************

	code section "code"



start:

	mov [dummy_label],eax



	;*************************************************************************

	; initialize COMMAND$

	;*************************************************************************



	invoke GetCommandLine

	invoke copy$,addr COMMAND$,eax



	; *****************************************************

	;  lib2obj version 0.1, by Greg Heller

	; *****************************************************

 

	; *****************************************************

	;  Main program begins here

	; *****************************************************

	invoke printf,<13,10,0>

	add esp,4

	invoke printf,<'Lib2Obj version 0.1, by Greg Heller.',13,10,0>

	add esp,4

	invoke printf,<'Released to the public domain.',13,10,0>

	add esp,4

	invoke printf,<'Use this program at your own risk, it is not well tested.',13,10,0>

	add esp,4

	invoke printf,<13,10,0>

	add esp,4

	invoke GetToken$,addr CommandLine$,addr COMMAND$,addr whitespace

	invoke GetToken$,addr InFile$,addr COMMAND$,addr whitespace

	cmp eax,-1

	jne > I34.0 

	invoke printf,<'Useage: Lib2Obj[.exe] whatever[.lib] [optional LIB arguments]',13,10,0>

	add esp,4

	jmp Quit

I34.0:

	invoke InString,1,addr InFile$,"."

	test eax,eax

	jne > I40.0 

	invoke copy$,addr OutFile$,addr InFile$

	invoke lstrcat,addr InFile$,".lib"

	jmp >> E40.0

I40.0:

	dec eax

	invoke left$,addr OutFile$,addr InFile$,eax

E40.0:

	invoke wsprintf,addr OutDirectory$,"%s",addr OutFile$

	add esp,12

	invoke printf,<'Creating output directory: %s',13,10,0>,addr OutFile$

	add esp,8

	invoke CreateDirectory,addr OutDirectory$,0

	invoke len,addr COMMAND$

	test eax,eax

	jne > I53.0 

	invoke copy$,addr COMMAND$,"/NOLOGO"

I53.0:

	invoke wsprintf,addr CommandLine$,"LIB /LIST:%s.lst %s %s",addr OutFile$,addr InFile$,addr COMMAND$

	add esp,20

	invoke printf,<'Creating output listing: %s.lst',13,10,0>,addr OutFile$

	add esp,8

	invoke system,addr CommandLine$

	test eax,eax

	jne > Quit

	invoke printf,<13,10,0>

	add esp,4

	invoke lstrcat,addr OutFile$,".lst"

	xor ebx,ebx

	invoke CreateFile,addr OutFile$,GENERIC_READ,ebx,ebx,OPEN_EXISTING,ebx,ebx

	mov d[hOutFile],eax

	cmp eax,INVALID_HANDLE_VALUE

	jne > I71.0 

	invoke printf,<'Lib2Obj internal file error.',13,10,0>

	add esp,4

	jmp > Quit

I71.0:

	invoke GetFileSize,eax,NULL

	inc eax

	mov d[byte_count],eax

	invoke malloc,eax

	mov d[lpOut],eax

	mov esi,eax

	test eax,eax

	jne > I84.0 

	invoke printf,<'Memory allocation error.',13,10,0>

	add esp,4

	jmp > Quit

I84.0:

	invoke ReadFile,[hOutFile],esi,[byte_count],addr my_Dword,0

	invoke CloseHandle,[hOutFile]

Scanner:

	mov edi,addr InText$

	invoke memfill,edi,0,sizeof InText$

ReadNextByte:

	dec d[byte_count]

	cmp d[byte_count],0

	je > I100.0 

	lodsb

	mov bl,al

	cmp bl,13

	je > I103.0 

	cmp bl,10

	je < ReadNextByte

	stosb

	jmp < ReadNextByte

I103.0:

I100.0:

	invoke rtrim$,addr InText$,addr InText$

	invoke len,addr InText$

	test eax,eax

	jng > I113.0 

	invoke printf,<'%s',13,10,0>,addr InText$

	add esp,8

	invoke wsprintf,addr CommandLine$,"LIB /EXTRACT:%s %s /OUT:%s\%s %s",addr InText$,addr InFile$,addr OutDirectory$,addr InText$,addr COMMAND$

	add esp,28

	inc d[object_count]

	invoke system,addr CommandLine$

	test eax,eax

	jne > Quit

I113.0:

	cmp d[byte_count],0

	jg Scanner 

	invoke lstrcat,addr OutDirectory$,"\"

	invoke lstrcat,addr OutDirectory$,addr OutFile$

	invoke MoveFile,addr OutFile$,addr OutDirectory$,MOVEFILE_REPLACE_EXISTING

	invoke printf,<13,10,0>

	add esp,4

	invoke printf,<'Sucessfully created %d object files.',13,10,0>,[object_count]

	add esp,8

Quit:

	invoke free,[lpOut]

	invoke ExitProcess,0

	; ******************************************************************************

InString FRAME startpos,lpSource,lpPattern

	uses ebx,esi,edi

	;  ******************************************************************

	;  InString searches for a substring in a larger string and if it is

	;  found,it returns its position in eax.

	;  It uses a one (1) based character index (1st character is 1,

	;  2nd is 2 etc...) for both the "StartPos" parameter and the returned

	;  character position.

	;  Return Values.

	;  If the function succeeds,it returns the 1 based index of the start

	;  of the substring.

	;   0 = no match found

	;  -1 = substring same length or longer than main string

	;  -2 = "StartPos" parameter out of range (less than 1 or longer than

	;  main string)

	;  ******************************************************************

	local pLen



	mov esi,[lpSource]

	mov edi,[lpPattern]

	invoke len,esi

	mov ebx,eax

	invoke len,edi

	mov ecx,[startpos]

	add edi,eax

	neg eax              						; edi+eax = start of pattern

	mov d[pLen],eax

	dec ecx

	js > E2	            					; startpos <= 0? yes - goto error -2

	add ebx,eax

	js > E1      	     						; if sLen < pLen goto error -1

	lea esi,[esi+ebx+1]   					; esi= address of part wich is < pLen

	not ebx          							; ebx = -(ebx+1)= - ((sLen - pLen)+1)

	add ecx,ebx

	jns > E2         	  						; ecx - ((sLen-pLen)+1) >= 0 and SF =0

	mov al,[edi+eax]

	jmp > L0

P1:

	pop ecx      							; restore ECX

	inc ecx

L0:

	cmp al,[esi+ecx]

	je > I182.0 

	inc ecx

	jnz < L0

	xor eax,eax

	ret

I182.0:

	push ecx    							; preserve ECX

	mov edx,[pLen]

S1:

	inc ecx

	inc edx

	mov ah,[esi+ecx]

	je > F1								; edi+0 = pattern end

	cmp ah,[edi+edx]

	je < S1

	jmp < P1

F1:

	pop eax

	sub eax,ebx

	ret

E2:

	mov eax,-2

	ret

E1:

	xor eax,eax

	dec eax

	ret

ENDFRAME

	; ******************************************************************************

GetToken$ FRAME lpToken$,lpInText$,lpEndChars

	uses ebx,esi,edi

	; ****************************************************

	;  Get the Token$

	; 		Returns:

	; 			-1 if InText$ is blank

	; ****************************************************

	local InChar



	local EndChar



	local lenInText



	local inQuotes



	invoke len,[lpToken$]

	invoke memfill,[lpToken$],0,eax

	invoke ltrim$,[lpInText$],[lpInText$]

	invoke len,[lpInText$]

	test eax,eax

	jne > I235.0 

	xor eax,eax

	dec eax

	ret

I235.0:

	mov d[lenInText],eax

	mov d[inQuotes],FALSE

	invoke len,[lpEndChars]

	mov ebx,eax

	inc ebx

	mov esi,[lpInText$]

	cld

	mov edx,[lpInText$]

	add edx,[lenInText]

	inc edx

0:

	lodsb

	cmp al,'"'

	jne > I256.0 

L0:

	cmp d[inQuotes],FALSE

	jne > I258.0 

	mov ah,al

	mov d[inQuotes],TRUE

	jmp > L4

I258.0:

	cmp ah,al

	jne > L4

	mov d[inQuotes],FALSE

	inc esi

	jmp > L5

I256.0:

	cmp al,"'"

	je < L0

	cmp d[inQuotes],TRUE

	je > I271.0 

	mov edi,[lpEndChars]

	mov ecx,ebx

	repne scasb									; compare the strings,repeat

	je > L5

I271.0:

L4:

	cmp esi,edx

	jne < 0

L5:

	mov ecx,esi

	dec ecx

	mov esi,[lpInText$]

	sub ecx,esi

	jnz >

	inc ecx

:

	mov edi,[lpToken$]

	rep movsb

	xor eax,eax

	stosb

	mov ecx,edx

	sub ecx,esi

	mov edi,[lpInText$]

	rep movsb

	stosb

	invoke ltrim$,[lpToken$],[lpToken$]

	invoke rtrim$,[lpToken$],[lpToken$]

	dec esi

	mov eax,esi

	ret

ENDFRAME



invoke ExitProcess,0



;*************************************************************************



;*************************************************************************



copy$ FRAME dest,source

	uses esi,edi,ebx

	mov esi,[source]

	mov edi,[dest]

	xor eax,eax

1:

	mov edx,[esi+eax]           ;read a dword

	mov ebx,edx                 ;use some regs to determine if dword

	lea ecx,[edx - 01010101h]   ;contains a zero byte

	xor edx,ecx

	and edx,80808080h

	and edx,ecx                 ;so does it contain a zero byte

	jnz > 3			            ;if yes, jump to copy remaining bytes

	mov D[edi+eax],ebx   		;if no copy the whole dword over

	add eax,4

	jmp 1

2:

	shr ebx,8

3:

	mov B[edi+eax],bl     		;copy the bytes out of ebx

	inc eax

	test bl,bl

	jnz 2

	lea eax,[eax+edi-1]

	ret

copy$ ENDF



;*************************************************************************



left$ FRAME Destination,Source,Length

	;*****************************************************************

	; Destination receives the leftmost Length characters of Source.

	; Return value undefined.

	;*****************************************************************

	uses esi,edi

	mov ecx,[Length]

	mov esi,[Source]

	mov edx,ecx

	mov edi,[Destination]

	and edx,3

	shr ecx,2

    cld                 ; read forward

	rep movsd

	lea ecx,[edx+1]

	rep movsb

	ret

left$ ENDF



;*************************************************************************



len FRAME item

	; -------------------------------------------------------------

  	; This procedure has been adapted from an algorithm written by

  	; Agner Fog. It has the unusual characteristic of reading up to

  	; three bytes past the end of the buffer as it uses DWORD size

  	; reads. It is measurably faster than a classic byte scanner on

  	; large linear reads and has its place where linear read speeds

  	; are important.

  	; -------------------------------------------------------------

    uses ebx

    mov eax,[item]             ; get pointer to string

    lea edx,[eax+3]            ; pointer+3 used in the end

1:

    mov ebx,[eax]              ; read first 4 bytes

    add eax,4                  ; increment pointer

    lea ecx,[ebx-01010101h]    ; subtract 1 from each byte

    not ebx                    ; invert all bytes

    and ecx,ebx                ; and these two

    and ecx,80808080h

    jz  1                      ; no zero bytes, continue loop

    test ecx,00008080h         ; test first two bytes

		jnz > 2

    shr ecx,16                 ; not in the first 2 bytes

    add eax,2

2:

    shl cl,1                   ; use carry flag to avoid branch

    sbb eax,edx                ; compute length

    ret

len ENDF



;*************************************************************************



memfill FRAME lpmem,fill,ln

	mov edx,[lpmem]    ; buffer address

	mov eax,[fill]     ; fill chars

	mov ecx,[ln]       ; byte length

	shr ecx,5          ; divide by 32

	cmp ecx,0

		jz > rmndr

	align 4

	;************

	; unroll by 8

	;************

L1:

	mov [edx],   eax   ; put fill chars at address in edx

	mov [edx+4], eax

	mov [edx+8], eax

	mov [edx+12],eax

	mov [edx+16],eax

	mov [edx+20],eax

	mov [edx+24],eax

	mov [edx+28],eax

	add edx,32

	dec ecx

	jnz < L1

	rmndr:

	and d[ln],31        ; get remainder

	cmp d[ln],0

		je > mfQuit

	add [ln],edx       ; exit condition

L2:

	mov [edx],eax

	add edx,4

	cmp edx,[ln]

	jle < L2

	mfQuit:

	ret

memfill ENDFRAME



;*************************************************************************



rtrim$ FRAME Destination,Source

	;********************************************************************

	; Destination receives Source trimmed of trailing spaces and tabs.

	; Return value undefined.

	;********************************************************************

	uses esi,edi

    mov esi,[Source]

    xor ecx,ecx        	; zero ecx to use as counter

L1:

    mov al,[esi]

    inc esi

    inc ecx            	; get string length excluding zero

    cmp al,0           	; exit loop on zero

    jne < L1

    lea esi,[esi-2]    	; correct esi count

L2:

    mov al,[esi]

    dec esi

    dec ecx

    cmp al,32          	; loop if space

    je  < L2

    cmp al,9           	; loop if tab

    je < L2

    cld                 ; read forward

    inc ecx

    mov esi,[Source]

    mov edi,[Destination]

    rep movsb

	dec edi

	mov [edi],B 0

    ret

rtrim$ ENDF



;*************************************************************************



ltrim$ FRAME Destination,Source

	;*******************************************************************

	; Destination receives Source trimmed of leading spaces and tabs.

	; Return value undefined.

	;*******************************************************************

    uses esi,edi

    mov esi,[Source]

    mov edi,[Destination]

    cld             	; read forward

1:

	lodsb

    cmp al,0     		; exit on zero

		je > L3

    cmp al,32    		; loop if space

    je 1

    cmp al,9     		; loop if tab

    je 1

    stosb

2:

    lodsb

    cmp al,0     		; exit on zero

		je > L3

    stosb

    jmp 2

L3:

    stosb         		; write terminating zero

    ret

ltrim$ ENDF

